#! /bin/sh

FIC_RESULTATS="resultats/aleatoires.txt"
FIC_DATA_READ="resultats/read-aleatoires.txt"
FIC_DATA_WRITE="resultats/write-aleatoires.txt"
FIC_GRAPHIQUE="resultats/graph-aleatoire.gif"

> "$FIC_RESULTATS"

N=1
P=$((512*1024*1024))

taskset -pc 0 $$

while [ "$P" -ge 1 ]
do
	echo "$N / $P " >&2
	echo "taille bloc : $N, nb_cycles : $P" >> "$FIC_RESULTATS"
	./acces-aleatoires-memoire "$N" "$P" >> "$FIC_RESULTATS"
	N=$((N<<1))
	P=$((P>>1))
done


grep ecriture < "$FIC_RESULTATS" | awk '{print $6}' > "$FIC_DATA_WRITE"
grep lecture  < "$FIC_RESULTATS" | awk '{print $6}' > "$FIC_DATA_READ"

echo "set terminal gif giant size 1600,1200;" \
     "set output '$FIC_GRAPHIQUE';"           \
     "set multiplot layout 2,1;"              \
     "set xlabel 'log2(nombre d entrees)'; "  \
     "set ylabel 'duree boucle (ns)'; "       \
     "plot   '$FIC_DATA_READ'  with line lc rgb '#0000FF';"  \
     "plot   '$FIC_DATA_WRITE' with line lc rgb '#FF0000'; " \
 | gnuplot

